/*  This code was written by Levi Smolin.  A BIG thanks to Jeff Molofee for the base code 
*   and pretty much this whole program.  Visit his website at nehe.gamedev.net for tons of 
*   tutorials and info.  
*/
#include <windows.h>		// Header File For Windows
#include <time.h>			// Header File For The Time Header so We can set the seed of the computers randomness.
#include <stdio.h>			// Header File For The Standard Input/Output
#include <scrnsave.h>		// Header File For the Scrnsave Library
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <gl\glaux.h>		// Header File For The Glaux Library
#include "resource.h"
#define	NP	500				// Number Of Particles To Create
HDC			hDC=NULL;		// Private GDI Device Context
HGLRC		hRC=NULL;		// Permanent Rendering Context
HWND		hWnd=NULL;		// Holds Our Window Handle
HINSTANCE	hInstance;		// Holds The Instance Of The Application
#pragma comment( lib, "opengl32.lib" )								// Search For OpenGL32.lib While Linking ( NEW )
#pragma comment( lib, "glu32.lib" )									// Search For GLu32.lib While Linking    ( NEW )
#pragma comment( lib, "glaux.lib" )	
#pragma comment( lib, "scrnsave.lib" )	
GLUquadricObj *sphere;	// Holds The Instance Of The Sphere used to create the Planets
GLuint texture[27];		// Holds our textures
bool	keys[256];			// Array Used For The Keyboard Routine
bool	active=TRUE;		// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default
int     loop;				// A helpful variable for loops
float rotm,rotv,rote,rotm1,rotj,rots,rotu,rotn,rotp,rotm2,roll,moon,zoom=-15.0f;
GLfloat LightAmbient[]= { 1.0f, 1.0f, 1.0f, 1.0f }; 				
GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f };				 
GLfloat LightPosition[]= { 0.0f,0.0f, -18, 1.0f };
GLfloat LightSpecular[] = {1.0, 1.0, 1.0, 1.0};		
GLfloat EmisMat[]= {0.2f, 0.2f, 0.2f, 1.0};
GLfloat NoMat[]={0.0,0.0,0.0,1.0};			 
typedef struct						// Create A Structure For Particles
{
	bool	active;					// Active (Yes/No)
	float	fade;					// Fade Speed
	float	x;						// X Position
	float	y;						// Y Position
	float	z;						// Z Position
}
	
control;
control particle[NP];

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc
void LoadGLTextures()											// Creates Textures From Bitmaps In The Resource File
{
	HBITMAP hBMP;												// Handle Of The Bitmap
	BITMAP	BMP;												// Bitmap Structure

	// The ID Of The 3 Bitmap Images We Want To Load From The Resource File
	byte	Texture[]={ IDB_EARTH,IDB_MOON,IDB_BITMAP2,IDB_MERCURY,IDB_VENUS,IDB_MARS,IDB_JUPITER,
						IDB_SATURN,IDB_URANUS,IDB_NEPTUNE,IDB_PLUTO,IDB_IO,IDB_EUROPA,IDB_GANYMEDE
						,IDB_CALLISTO,IDB_RHEA,IDB_MIMAS,IDB_TETHYS,IDB_DIONE,IDB_TITAN,IDB_MIRANDA
						,IDB_ARIEL,IDB_TITANIA,IDB_OBERON,IDB_UMBRIEL,IDB_CHARON};

	glGenTextures(sizeof(Texture), &texture[0]);				// Generate 3 Textures (sizeof(Texture)=3 ID's)
	for (int loop=0; loop<sizeof(Texture); loop++)				// Loop Through All The ID's (Bitmap Images)
	{
		hBMP=(HBITMAP)LoadImage(GetModuleHandle(NULL),MAKEINTRESOURCE(Texture[loop]), IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
		if (hBMP)												// Does The Bitmap Exist?
		{														// If So...
			GetObject(hBMP,sizeof(BMP), &BMP);					// Get The Object
																// hBMP: Handle To Graphics Object
																// sizeof(BMP): Size Of Buffer For Object Information
																// Buffer For Object Information
			glPixelStorei(GL_UNPACK_ALIGNMENT,4);				// Pixel Storage Mode (Word Alignment / 4 Bytes)
			glBindTexture(GL_TEXTURE_2D, texture[loop]);		// Bind Our Texture
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR); // Mipmap Linear Filtering

			// Generate Mipmapped Texture (3 Bytes, Width, Height And Data From The BMP)
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, BMP.bmWidth, BMP.bmHeight, GL_BGR_EXT, GL_UNSIGNED_BYTE, BMP.bmBits);
			DeleteObject(hBMP);									// Delete The Bitmap Object
		}
	}
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

void InitOpenGL(GLsizei width, GLsizei height)
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective (45.0f, (GLfloat)(width)/(GLfloat)(height),1.0f, 1000.0f);		

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();
		// Start Of User Initialization
	LoadGLTextures();									// Load The Textures From Our Resource File
	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);				// Setup The Ambient Light
	glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);				// Setup The Diffuse Light
	glLightfv(GL_LIGHT1, GL_SPECULAR, LightSpecular);			// Setup The Specular Lighta
	glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);			// Position The Light
	glClearColor (0.0f, 0.0f, 0.0f, 0.5f);				// Black Background
	glClearDepth (1.0f);								// Depth Buffer Setup
	glEnable(GL_COLOR);
	glEnable(GL_LIGHT1);
	glDepthFunc (GL_LEQUAL);							// The Type Of Depth Testing (Less Or Equal)
	glEnable(GL_DEPTH_TEST);							// Disable Depth Testing
	glShadeModel (GL_SMOOTH);							// Select Smooth Shading
	glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Set Perspective Calculations To Most Accurate
	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);					// Type Of Blending To Perform
	glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);	// Really Nice Perspective Calculations
	glHint(GL_POINT_SMOOTH_HINT,GL_NICEST);				// Really Nice Point Smoothing	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_BACK);
	srand(time(NULL));
for (loop=0;loop<NP;loop++)				
	{
		particle[loop].active=true;							
		particle[loop].x=float((rand()%-100)-50);	
		particle[loop].y=float((rand()%-100)-50);		
		particle[loop].z=float((rand()%-5));		
	}
	sphere=gluNewQuadric();
    gluQuadricTexture(sphere, GLU_TRUE);
    gluQuadricDrawStyle(sphere, GLU_FILL); 
}
int DrawGLScene(GLvoid)									
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	glLoadIdentity();
	gluLookAt(0,0,-90,0,0,0,0,1,0);
	glTranslatef(0,0,-1);
	glNormal3f( 0.0f, 0.0f, -1.0f);	
	for (loop=0;loop<NP;loop++)					// Loop Through All The Particles
	{
			float x=particle[loop].x;						// Grab Our Particle X Position
			float y=particle[loop].y;						// Grab Our Particle Y Position
			float z=particle[loop].z+zoom;					// Particle Z Pos + Zoom
	glDisable(GL_TEXTURE_2D);
	glColor4f(1.0f,1.0f,1.0f,1.0f);
	glBegin(GL_POINTS);						// Build Quad From A Triangle Strip
			   glVertex3f(x,y,z); // Top Right
			glEnd();										// Done Building Triangle Strip
	glEnable(GL_TEXTURE_2D);
	}
//******************************************************
		//Sun
	glLoadIdentity();
//	glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,EmisMat);
	gluLookAt(0,0,-24,0,0,0,0,1,0);
	glTranslatef(0.0f,0.0f,-4);
	glRotatef(80,1,0,0);
	glRotatef(5,0,1,0);
	glRotatef(roll,0,0,1);
	glBindTexture(GL_TEXTURE_2D,texture[2]);
	gluSphere(sphere, 0.8, 20,20);
	roll+=0.1f;
 //	glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,NoMat);
//******************************************************
//******************************************************
//Mercury
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rotm,0.0f,1.0f,0.0f);
//gluSphere(sphere,0.1,1,1);
glTranslatef(-1.0f,0.0f,-1.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[3]);
gluSphere(sphere,0.15,20,20);
rotm+=1.2f;

	//End Mercury
//******************************************************
//******************************************************
//Venus
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rotv,0.0f,1.0f,0.0f);
//gluSphere(sphere,0.1,1,1);
glTranslatef(-1.0f,0.0f,2.3f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[4]);
gluSphere(sphere,0.3,20,20);
rotv+=1.0f;


	//End Venus
//******************************************************
//******************************************************
//Earth
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rote,0.0f,1.0f,0.0f);
glTranslatef(-1.0f,0.0f,-3.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[0]);
gluSphere(sphere,0.2,20,20);
rote+=0.9f;


	//End Earth
//******************************************************
//******************************************************
//Moon

glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rote,0.0f,0.0f,-1.0f);
gluSphere(sphere,0.1f,20,20);
glTranslatef(0.5f,0.0f,0.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[1]);
gluSphere(sphere,0.05,20,20);


	//End Moon
//******************************************************
//******************************************************
//Mars
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rotm1,0.0f,1.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glTranslatef(-1.0f,0.0f,-4.4f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[5]);
gluSphere(sphere,0.15f,20,20);
rotm1+=0.85f;


	//End Mars
//******************************************************
//******************************************************
//Mars Moons

glTranslatef(0.0f,0.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glRotatef(moon,0.0f,0.0f,-1.0f);
gluSphere(sphere,0.1f,20,20);
glTranslatef(0.3f,0.0f,0.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[1]);
gluSphere(sphere,0.07,20,20);
glTranslatef(-0.6f,0.0f,0.0f);
gluSphere(sphere,0.05,20,20);
moon+=1.0f;

	//End Mars Moons
//******************************************************
//******************************************************
//Jupiter
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rotj,0.0f,1.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glTranslatef(-1.0f,0.0f,5.4f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[6]);
gluSphere(sphere,0.4f,20,20);
rotj+=0.7f;


	//End Jupiter
//******************************************************
//******************************************************
//Jupiter Moons

glTranslatef(0.0f,0.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glRotatef(rotm1,0.0f,0.0f,-1.0f);
gluSphere(sphere,0.1f,20,20);
glTranslatef(0.5f,0.0f,0.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[11]);
gluSphere(sphere,0.1,20,20);
glBindTexture(GL_TEXTURE_2D,texture[12]);
glTranslatef(-1.0f,0.0f,0.0f);
gluSphere(sphere,0.05,20,20);
glBindTexture(GL_TEXTURE_2D,texture[13]);
glTranslatef(-0.1f,0.0f,-0.2f);
gluSphere(sphere,0.05,20,20);
glBindTexture(GL_TEXTURE_2D,texture[14]);
glTranslatef(0.5f,0.1f,-0.4f);
gluSphere(sphere,0.05,20,20);


	//End Jupiter Moons
//******************************************************
//******************************************************
//Saturn
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rots,0.0f,1.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glTranslatef(-1.0f,0.0f,6.4f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[7]);
gluSphere(sphere,0.25f,20,20);
rots+=0.65f;


	//End Saturn
//******************************************************
//******************************************************
//Saturn Moons

glTranslatef(0.0f,0.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glRotatef(moon,0.0f,0.0f,-1.0f);
gluSphere(sphere,0.1f,20,20);
glTranslatef(0.5f,0.0f,0.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[15]);
gluSphere(sphere,0.02,20,20);
glBindTexture(GL_TEXTURE_2D,texture[16]);
glTranslatef(-1.0f,0.0f,0.0f);
gluSphere(sphere,0.08,20,20);
glBindTexture(GL_TEXTURE_2D,texture[17]);
glTranslatef(0.0f,-0.2f,0.0f);
gluSphere(sphere,0.03,20,20);
glBindTexture(GL_TEXTURE_2D,texture[18]);
glTranslatef(1.0f,0.0f,-0.4f);
gluSphere(sphere,0.07,20,20);
glBindTexture(GL_TEXTURE_2D,texture[19]);
glTranslatef(0.0f,0.2f,0.6f);
gluSphere(sphere,0.05,20,20);


	//End Saturn Moons
//******************************************************
//******************************************************
//Uranus
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rotu,0.0f,1.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glTranslatef(-1.0f,0.0f,-7.4f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[8]);
gluSphere(sphere,0.25f,20,20);
rotu+=0.61f;


	//End Uranus
//******************************************************
//******************************************************
//Uranus Moons

glTranslatef(0.0f,0.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glRotatef(rotm1,0.0f,0.0f,-1.0f);
gluSphere(sphere,0.1f,20,20);
glTranslatef(0.5f,0.0f,0.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[20]);
gluSphere(sphere,0.02,20,20);
glBindTexture(GL_TEXTURE_2D,texture[21]);
glTranslatef(-1.0f,0.0f,0.0f);
gluSphere(sphere,0.08,20,20);
glBindTexture(GL_TEXTURE_2D,texture[22]);
glTranslatef(0.0f,-0.2f,0.0f);
gluSphere(sphere,0.03,20,20);
glBindTexture(GL_TEXTURE_2D,texture[23]);
glTranslatef(1.0f,0.0f,-0.4f);
gluSphere(sphere,0.07,20,20);
glBindTexture(GL_TEXTURE_2D,texture[24]);
glTranslatef(0.0f,0.2f,0.6f);
gluSphere(sphere,0.05,20,20);


	//End Uranus Moons
//******************************************************
//******************************************************
//Neptune
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rotn,0.0f,1.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glTranslatef(-1.0f,0.0f,-8.4f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[9]);
gluSphere(sphere,0.25f,20,20);
rotn+=0.57f;


	//End Neptune
//******************************************************
//******************************************************
//Neptunes Moons

glTranslatef(0.0f,0.0f,0.0f);
gluSphere(sphere,0.05,1,1);
glRotatef(moon,0.0f,0.0f,-1.0f);
gluSphere(sphere,0.1f,20,20);
glTranslatef(0.5f,0.0f,0.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[1]);
gluSphere(sphere,0.07,20,20);
glTranslatef(-0.5f,0.0f,0.4f);
gluSphere(sphere,0.05,20,20);



	//End Neptunes Moons
//******************************************************
//******************************************************
//Pluto
glLoadIdentity();
gluLookAt(0,6,-18,0,0,0, 0,1,0);
glTranslatef(0.0f,0.0f,0.0f);
glRotatef(rotp,0.0f,1.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glTranslatef(-1.0f,0.0f,-9.4f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[10]);
gluSphere(sphere,0.20f,20,20);
rotp+=0.55f;


	//End Pluto
//******************************************************
//******************************************************
//Plutos Moon

glTranslatef(0.0f,0.0f,0.0f);
gluSphere(sphere,0.1,1,1);
glRotatef(rotm1,0.0f,0.0f,-1.0f);
gluSphere(sphere,0.1f,20,20);
glTranslatef(0.5f,0.0f,0.0f);
glRotatef(90,1.0f,0.0f,0.0f);
glRotatef(15,1.0f,0.0f,0.0f);
glBindTexture(GL_TEXTURE_2D,texture[25]);
gluSphere(sphere,0.05,20,20);


	//End Plutos Moon
//******************************************************
glEnd();
	return TRUE;										// Everything Went OK
}
GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}
	
	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

 
HGLRC InitOGLWindow(HWND hWnd)
{
	HDC hDC = GetDC(hWnd);
	HGLRC hRC = 0;
	PIXELFORMATDESCRIPTOR pfd;
	int nFormat;

	ZeroMemory(&pfd, sizeof(PIXELFORMATDESCRIPTOR));

	pfd.nSize = sizeof(PIXELFORMATDESCRIPTOR);
	pfd.nVersion = 1;
	pfd.dwFlags = PFD_SUPPORT_OPENGL | PFD_DRAW_TO_WINDOW | PFD_DOUBLEBUFFER;
	pfd.cColorBits = 24;
	pfd.cDepthBits = 24;
	
	nFormat = ChoosePixelFormat(hDC, &pfd);
	DescribePixelFormat(hDC, nFormat, sizeof(PIXELFORMATDESCRIPTOR), &pfd);
	SetPixelFormat(hDC, nFormat, &pfd);
	
	hRC = wglCreateContext(hDC);
	wglMakeCurrent(hDC, hRC);

	ReleaseDC(hWnd, hDC);

	return hRC;
}
LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}
		
		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}



// needed for SCRNSAVE.LIB
BOOL WINAPI RegisterDialogClasses(HANDLE hInst)
{
  return TRUE;
}




BOOL WINAPI
ScreenSaverConfigureDialog(HWND hDlg, UINT message, 
                           WPARAM wParam, LPARAM lParam)
{
    return FALSE;
}



LRESULT WINAPI ScreenSaverProc(HWND hWnd, UINT message, 
					 WPARAM wParam, LPARAM lParam) 
{
	static HGLRC hRC;
	static DWORD timer = 1;
	HDC hDC;

	switch (message) 
	{ 
	case WM_CREATE: 
		hRC = InitOGLWindow(hWnd);
		RECT		WindowRect;	
		int width;
		int height;
		GetClientRect (hWnd, &WindowRect); 
		width = WindowRect.right - WindowRect.left;
		height = WindowRect.bottom - WindowRect.top;
		InitOpenGL(width,height);
		SetTimer(hWnd, timer, 5, NULL);
		break; 
	case WM_TIMER:
		hDC = GetDC(hWnd);
		DrawGLScene();
		SwapBuffers(hDC);
		ReleaseDC(hWnd, hDC);
		break;
	case WM_DESTROY: 
		wglMakeCurrent(NULL, NULL);
		wglDeleteContext(hRC);
		break;
	} 

	return DefScreenSaverProc(hWnd, message, wParam, lParam);
}